using System;
using System.Collections.Generic;
using System.Linq;
using MySystem.MainModels;

namespace MySystem
{
    public class OrderProductDbconn
    {
        public readonly static OrderProductDbconn Instance = new OrderProductDbconn();

        #region 获取单个字段
        public OrderProduct Get(int Id)
        {
            WebCMSEntities db = new WebCMSEntities();
            OrderProduct orderPro = db.OrderProduct.FirstOrDefault(m => m.Id == Id);
            if (orderPro != null)
            {
            }
            db.Dispose();
            return orderPro;
        }
        #endregion


        #region 获取列表
        public List<int> GetList(int OrderId, int pageNum = 1, int pageSize = 10)
        {
            string key = "OrderProductList:" + OrderId;
            List<int> list = new List<int>();
            if (RedisDbconn.Instance.Exists(key))
            {
                list = RedisDbconn.Instance.GetList<int>(key, pageNum, pageSize);
                if (list.Count > 0)
                {
                    return list;
                }
            }
            List<int> newlist = new List<int>();
            RedisDbconn.Instance.GetLock(key + ":lock");
            WebCMSEntities db = new WebCMSEntities();
            var mysqllist = db.OrderProduct.Select(m => new { m.Id, m.OrderId }).Where(m => m.OrderId == OrderId).OrderByDescending(m => m.Id).ToList();
            if (mysqllist.Count > 0)
            {
                foreach (var sub in mysqllist)
                {
                    newlist.Add(sub.Id);
                }
                RedisDbconn.Instance.Clear(key);
                foreach (int sub in newlist)
                {
                    RedisDbconn.Instance.AddRightList(key, sub);
                }
                RedisDbconn.Instance.SetExpire(key, Library.function.get_Random(1800, 5400));
            }
            db.Dispose();
            RedisDbconn.Instance.ReleaseLock(key + ":lock");
            return newlist;
        }
        #endregion
    }
}
